# gcmfaces

[This repository][] contains the gcmfaces Matlab / Octave toolbox and [its documentation](http://gcmfaces.readthedocs.io/). For user support, if needed, contact <mitgcm-support@mit.edu> or <ecco-support@mit.edu>. Citation for this repository: 

[![DOI](https://zenodo.org/badge/62541910.svg)](https://zenodo.org/badge/latestdoi/62541910)

[This repository]: https://github.com/gaelforget/gcmfaces

**gcmfaces** is a Matlab toolbox designed to analyze results of [MITgcm](http://mitgcm.org/) simulations, including [ECCOv4 solutions](http://eccov4.readthedocs.io/), and to handle gridded earth variables in generic fashion (Forget et al 2015). It allows users to seamlessly deal with various gridding approaches (e.g., all grids distributed via [this FTP server](ftp://mit.ecco-group.org/ecco_for_las/version_4/grids/)) using compact and generic codes as explained in [the toolbox documentation](http://gcmfaces.readthedocs.io/). It includes many basic and more evolved functionalities for plotting global maps, computing transports and budgets, etc. as illustrated by [gcmfaces_demo.m](gcmfaces_demo.m) and the standard analysis (see Forget et al., 2015, 2016).  

Forget, G., J.-M. Campin, P. Heimbach, C. N. Hill, R. M. Ponte, and C. Wunsch, 2015: ECCO version 4: an integrated framework for nonlinear inverse modeling and global ocean state estimation. Geoscientific Model Development, 8 (10), 3071–3104, doi:10.5194/gmd-8-3071-2015, URL <http://www.geosci-model-dev.net/8/3071/2015/>

Forget, G., J.-M. Campin, P. Heimbach, C. N. Hill, R. M. Ponte, and C. Wunsch, 2016: ECCO Version 4: Second Release, http://hdl.handle.net/1721.1/102062, URL <https://dspace.mit.edu/bitstream/handle/1721.1/102062/standardAnalysis.pdf?sequence=1>

